<?php
// LICENSE
/*
DiggerDiff v1.2
Copyright (c) 2003, Dave Walton
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
*/
// END LICENSE


function action_config($config) {
  global $HTTP_SERVER_VARS, $HTTP_SESSION_VARS;
  $sid = strip_tags(SID);
  $php_self = $HTTP_SERVER_VARS['PHP_SELF'];
  $diffshow = $HTTP_SESSION_VARS['diffshow'];
  $perpage = $HTTP_SESSION_VARS['perpage'];
  $mainsize = $HTTP_SESSION_VARS['mainsize'];
  $diffsize = $HTTP_SESSION_VARS['diffsize'];
  $rows = $HTTP_SESSION_VARS['rows'];
  $columns = $HTTP_SESSION_VARS['columns'];
  $comments = $HTTP_SESSION_VARS['comments'];
  $sorturls = $HTTP_SESSION_VARS['sorturls'];
  $urlfile = $HTTP_SESSION_VARS['urlfile'];
  $editselectlines = $HTTP_SESSION_VARS['editselectlines'];
  $editselectwidth = $HTTP_SESSION_VARS['editselectwidth'];
  $editlines = $HTTP_SESSION_VARS['editlines'];
  $editwidth = $HTTP_SESSION_VARS['editwidth'];

  echo print_header('strict', '- Configure Session');
  echo "<body>\n";

//  var_dump($HTTP_SESSION_VARS);

?>

<form method="get" action="<?php echo $php_self; ?>">

<table border="0">
  <tr>
    <!-- COLUMN 1 -->
    <td valign="top">
      <!-- MAIN WINDOW CONFIG -->
      <table border="1" width="100%">
        <tr><th colspan="2"><u>MAIN WINDOW CONFIG</u></th></tr>
        <tr>
          <th>FRAME</th>
	  <td>
	    <table border="0">
	      <tr>
                <th align="right">Layout:</th>
                <td>
                  <?php echo form_input('radio', 'mainlayout', 'single', 'main-single', 'Single'); ?>
                  <?php echo form_input('radio', 'mainlayout', 'split', 'main-split', 'Split'); ?>
                </td>
              </tr>
              <tr>
                <th align="right">Divider:</th>
                <td>
                  <?php echo form_input('radio', 'maindivider', 'horiz', 'main-horiz', 'Horizontal'); ?>
                  <?php echo form_input('radio', 'maindivider', 'vert', 'main-vert', 'Vertical'); ?>
                </td>
              </tr>
              <tr>
                <th align="right">Size:</th>
                <td><?php echo form_input('text', 'mainsize', $mainsize); ?></td>
              </tr>
	    </table>
	  </td>
	</tr>
      </table>
      <br />

      <!-- DIFF CONFIG -->
      <table border="1" width="100%">
        <tr><th colspan="2"><u>DIFF CONFIG</u></th></tr>
        <tr>
          <th>FRAME</th>
          <td>
            <table border="0">
              <tr>
                <th align="right">Layout:</th>
                <td>
                  <?php echo form_input('radio', 'difflayout', 'single', 'diff-single', 'Single'); ?>
                  <?php echo form_input('radio', 'difflayout', 'split', 'diff-split', 'Split'); ?>
                </td>
              </tr>
              <tr>
                <th align="right">Divider:</th>
                <td>
                  <?php echo form_input('radio', 'diffdivider', 'horiz', 'diff-horiz', 'Horizontal'); ?>
                  <?php echo form_input('radio', 'diffdivider', 'vert', 'diff-vert', 'Vertical'); ?>
                </td>
              </tr>
              <tr>
                <th align="right">Style:</th>
                <td>
                  <?php echo form_input('radio', 'diffstyle', 'render', 'diff-render', 'Rendered'); ?>
                  <?php echo form_input('radio', 'diffstyle', 'source', 'diff-source', 'Source'); ?>
                </td>
              </tr>
              <tr>
                <th align="right">Size:</th>
                <td><?php echo form_input('text', 'diffsize', $diffsize); ?></td>
              </tr>
            </table>
          </td>
        </tr>

        <tr>
          <th>FORMAT</th>
          <td>
            <table border="0">
              <tr>
                <th align="right">Rendered:</th>
                <td>
                  <?php echo form_input('radio', 'diffrendermode', 'br', 'diff-render-br', '&lt;BR&gt;'); ?>
                  <?php echo form_input('radio', 'diffrendermode', 'pre', 'diff-render-pre', '&lt;PRE&gt;'); ?>
                </td>
              </tr>
              <tr>
                <th align="right">Source:</th>
                <td>
                  <?php echo form_input('radio', 'diffsourcemode', 'br', 'diff-source-br', '&lt;BR&gt;'); ?>
                  <?php echo form_input('radio', 'diffsourcemode', 'pre', 'diff-source-pre', '&lt;PRE&gt;'); ?>
                </td>
              </tr>
              <tr>
                <th align="right">Filter:</th>
                <td><?php echo form_input('text', 'diffshow', $diffshow); ?></td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
      <br />

      <!-- MISC CONFIG -->
      <table border="1" width="100%">
        <tr><th colspan="2"><u>MISC CONFIG</u></th></tr>
        <tr>
	  <th>URL FILE</th>
	  <td>
	    <table border="0">
	      <tr>
                <th align="right">Select File:</th>
                <td>
		  <select name="urlfile">
<?php
  $dirname = $config['pagepath'];
  $dir = opendir($dirname);
  while (FALSE !== ($filename = readdir($dir))) {
    if (preg_match('/^([^\W_]+)\.dat$/', $filename, $matches) > 0) {
      $datfile = $matches[1];
      echo "                    <option value=\"$datfile\" ";
      if ($datfile === $urlfile) {
        echo 'selected="selected" ';
      }
      echo ">$datfile</option>\n";
    }
  }
  closedir($dir);
?>
		  </select>
		</td>
	      </tr>
	      <tr>
	        <th align="right">Create File:</th>
                <td><?php echo form_input('text', 'newurlfile', $newurlfile); ?></td>
	      </tr>
	    </table>
	  </td>
	</tr>
      </table>
      <br />

    </td>

    <td>&nbsp;</td>

    <!-- COLUMN 2 -->
    <td valign="top">
      <!-- VIEW LIST CONFIG -->
      <table border="1" width="100%">
        <tr><th colspan="2"><u>SITE LIST CONFIG</u></th></tr>
        <tr>
	  <th>OPTIONS</th>
	  <td>
	    <table border="0">
	      <tr>
                <th align="right">Sites Per Page:</th>
                <td><?php echo form_input('text', 'perpage', $perpage); ?></td>
	      </tr>
	      <tr>
                <th align="right" valign="top">Toggles:</th>
		<td>
		  <?php echo form_input('checkbox', 'sorturls', '', 'sorturls', 'Sort List'); ?>
		  <br />
		  <?php echo form_input('checkbox', 'comments', '', 'comments', 'Show Comments'); ?>
		  <br />
		  <?php echo form_input('checkbox', 'ranges', '', 'ranges', 'Show Page Ranges'); ?>
	        </td>
	      </tr>
	    </table>
	  </td>
	</tr>
	<tr>
	  <th>PAGE<br />ELEMENTS</th>
	  <td>
	    <table border="0">
	      <tr>
	        <th align="right" valign="top">Rows:</th>
		<td><textarea name="rows">
<?php
  foreach($rows as $row) {
    echo "$row\n";
  }
?></textarea></td>
	      </tr>
	      <tr>
	        <th align="right" valign="top">Columns:</th>
		<td><textarea name="columns">
<?php
  foreach($columns as $column) {
    echo "$column\n";
  }
?></textarea></td>
	      </tr>
	    </table>
	  </td>
        </tr>
      </table>
      <br />

      <!-- EDIT CONFIG -->
      <table border="1" width="100%">
        <tr><th colspan="2"><u>EDIT CONFIG</u></th></tr>
        <tr>
          <th>SELECT<br />LIST</th>
	  <td>
	    <table border="0">
              <tr>
                <th align="right">Lines:</th>
                <td><?php echo form_input('text', 'editselectlines', $editselectlines); ?></td>
              </tr>
              <tr>
                <th align="right">Width:</th>
                <td><?php echo form_input('text', 'editselectwidth', $editselectwidth); ?></td>
              </tr>
	    </table>
	  </td>
	</tr>
        <tr>
          <th>FIELDS</th>
	  <td>
	    <table border="0">
              <tr>
                <th align="right">Lines:</th>
                <td><?php echo form_input('text', 'editlines', $editlines); ?></td>
              </tr>
              <tr>
                <th align="right">Width:</th>
                <td><?php echo form_input('text', 'editwidth', $editwidth); ?></td>
              </tr>
	    </table>
	  </td>
	</tr>
      </table>
      <br />

    </td>
  </tr>

  <!-- BUTTONS -->
  <tr>
    <td align="center" colspan="3">
      <?php echo form_input('hidden', session_name(), session_id()); ?>
      <?php echo form_input('hidden', 'action', 'list'); ?>
      <?php echo form_input('reset'); ?>
      <?php echo form_input('submit', 'apply', 'Done'); ?>
      </form>
    </td>
  </tr>
  <tr>
    <td align="center" colspan="3">
      <form method="get" action="<?php echo $php_self; ?>">
<?php
  foreach ($HTTP_SESSION_VARS as $var => $val) {
    if (($var === 'page') || ($var === 'filtersite')) {
      continue;
    }
    $val = $config['default'][$var];
    if (is_array($val)) {
      foreach ($val as $element) {
        echo form_input('hidden', $var."[]", $element);
      }
    } else {
      echo form_input('hidden', $var, $val);
    }
  }
  echo form_input('hidden', session_name(), session_id());
  echo form_input('submit', 'apply', 'Use Defaults');
?>
      </form>
    </td>
  </tr>
</table>

</body>
</html>

<?php

}


function form_input($type, $name='', $value='', $id='', $label='') {
  global $HTTP_SESSION_VARS;

  $output = '';
  switch($type) {
    case 'checkbox':
      $output .= "<input type=\"$type\" ";
      $output .= "name=\"$name\" value=\"TRUE\" id=\"$id\" ";
      $output .= ($HTTP_SESSION_VARS[$name] === TRUE) ? 'checked="checked" ' : '';
      $output .= "/><label for=\"$id\">$label</label>";
      break;
    case 'hidden':
      $output .= "<input type=\"$type\" ";
      if (is_bool($value)) {
        $value = ($value) ? 'TRUE' : 'FALSE';
      }
      $output .= "name=\"$name\" value=\"$value\" />";
      break;
    case 'radio':
      $output .= "<input type=\"$type\" ";
      $output .= "name=\"$name\" value=\"$value\" id=\"$id\" ";
      $output .= ($HTTP_SESSION_VARS[$name] === "$value") ? 'checked="checked" ' : '';
      $output .= "/><label for=\"$id\">$label</label>";
      break;
    case 'reset':
      $output .= "<input type=\"$type\" ";
      $output .= "/>";
      break;
    case 'submit':
      $output .= "<input type=\"$type\" ";
      $output .= "name=\"$name\" value=\"$value\" />";
      break;
    case 'text':
      $output .= "<input type=\"$type\" ";
      $output .= "name=\"$name\" value=\"$value\" size=\"5\" />";
      break;
    default:
      break;
  }

  return($output);
}


?>
